Index: channels/chan_skinny.c
===================================================================
--- channels/chan_skinny.c	(revision 14319)
+++ channels/chan_skinny.c	(working copy)
@@ -2321,7 +2321,7 @@
 	struct ast_frame f = { 0, };
 	struct sockaddr_in sin;
 	struct sockaddr_in us;
-	struct skinny_line *lines;
+	struct skinny_line *l;
 	char name[16];
 	char addr[4];
 	char d;
@@ -2633,16 +2633,40 @@
 			ast_log(LOG_NOTICE, "No available lines on: %s\n", s->device->name);
 			return 0;
 		}
-		lines = sub->parent;
+		l = sub->parent;
 		ast_mutex_lock(&devicelock);
-		for (i=1; i < lineNumber; i++) {
-			lines = lines->next;
+
+		/* Okay, it appears that if there are 3 "lines",
+		   s->device->lines is #1
+		   s->device->lines->sub is #2
+		   s->device->lines->sub->next is #3 */
+		i = 0;
+		while (l) {
+			if (++i == lineNumber)
+				break;
+			sub = l->sub;
+			while (sub) {
+				if (++i == lineNumber) {
+					l = sub->parent;
+					break;
+				}
+				sub = sub->next;
+			}
+			if (i == lineNumber)
+				break; /* The line is really a sub channel. */
+			l = l->next;
 		}
+
+		if (!l) {
+			ast_log(LOG_NOTICE, "Could not find line %d on: %s\n", lineNumber, s->device->name);
+			return 0;
+		}
+
 		ast_mutex_unlock(&devicelock);
 		req->data.linestat.linenumber = letohl(lineNumber);
-		memcpy(req->data.linestat.lineDirNumber, lines->name,
+		memcpy(req->data.linestat.lineDirNumber, l->name,
 				sizeof(req->data.linestat.lineDirNumber));
-		memcpy(req->data.linestat.lineDisplayName, lines->label,
+		memcpy(req->data.linestat.lineDisplayName, l->label,
 				sizeof(req->data.linestat.lineDisplayName));
 		transmit_response(s,req);
 		break;
